<div id="divMap"></div> 

<script>
  /* Create map */        
  var points = [],
    msg_el = document.getElementById('msg'),
    url_osrm_nearest = '//router.project-osrm.org/nearest/v1/driving/',
    url_osrm_route = '//router.project-osrm.org/route/v1/driving/',
    icon_url = '/assets/img/point.png',
    vectorSource = new ol.source.Vector(),
    vectorLayer = new ol.layer.Vector({
      source: vectorSource
    }),
    styles = {
      route: new ol.style.Style({
        stroke: new ol.style.Stroke({
          width: 6, color: [40, 40, 40, 0.8]
        })
      }),
      icon: new ol.style.Style({
        image: new ol.style.Icon({
          anchor: [0.5, 0.5],
          src: icon_url
        })
      })
    };

  var map = new ol.Map({
    target: 'divMap',
    layers: [
      new ol.layer.Tile({
        source: new ol.source.OSM()
      }),
      vectorLayer
    ],
    view: new ol.View({
      center: [-9342052, 1103482],
      zoom: 11
    })
  });

 function draw(coordinate){
    utils.getNearest(coordinate).then(function(coord_street){
      var last_point = points[points.length - 1];
      var points_length = points.push(coord_street);

      utils.createFeature(coord_street);

      /* First point case */
      if (points_length < 2) {
        return;
      }

      var point1 = last_point.join();
      var point2 = coord_street.join();
      
      fetch(url_osrm_route + point1 + ';' + point2).then(function(r) { 
        return r.json();
      }).then(function(json) {
         // utils.createRoute(json.routes[0].geometry);
      });
    });
  }

  var utils = {
    getNearest: function(coord){
      var coord4326 = utils.to4326(coord);    
      return new Promise(function(resolve, reject) {
     
        fetch(url_osrm_nearest + coord4326.join()).then(function(response) { 
          return response.json();
        }).then(function(json) {
          if (json.code === 'Ok') resolve(json.waypoints[0].location);
          else reject();
        });
      });
    },
    createFeature: function(coord) {
      var feature = new ol.Feature({
        type: 'place',
        geometry: new ol.geom.Point(ol.proj.fromLonLat(coord))
      });
      feature.setStyle(styles.icon);
      vectorSource.addFeature(feature);
    },
    createRoute: function(polyline) {
      var route = new ol.format.Polyline({
        factor: 1e5
      }).readGeometry(polyline, {
        dataProjection: 'EPSG:4326',
        featureProjection: 'EPSG:3857'
      });
      var feature = new ol.Feature({
        type: 'route',
        geometry: route
      });
      feature.setStyle(styles.route);
      vectorSource.addFeature(feature);
    },
    to4326: function(coord) {
      return ol.proj.transform([
        parseFloat(coord[0]), parseFloat(coord[1])
      ], 'EPSG:3857', 'EPSG:4326');
    }
  };

  /* Refresh markers */
  function refresh_front_end_map () {
    vectorSource.clear();
    get_markers();
  }

  /* Clean */
  function clean_front_end_map () {
    vectorSource.clear();
  }
  
  /* Get markers function */
  function get_markers() {
    $.getJSON("/get_trace_points", function(data) {
      /* Add markers */
      if(data.error == 0)
      {
        /* Markers */
        var position;
        data.results.forEach(function(element) {
          /* Data available */
          var lat = element.location.lat;
          var lon = element.location.lon;
          /* Create marker */
          position = ol.proj.fromLonLat([lon, lat]);
          draw(position);
        }, this);
      }
      else
      {
          /* Error case */
          alert("Error: It was not possible to retrieve points");
      }
    });
  }

</script>